#ifndef lint
static char *Solbourne_id =
"@(#) stubs.c 1.2@(#) Solbourne id 3/10/94 21:15:24\n";
#endif
/*
 * Copyright 1988 Solbourne Computer, Inc.
 * All rights reserved.
 */

#ifndef lint
static	char sccsid[] = "@(#)stubs.c 1.3 90/12/05 SMI";
#endif

/*
 * Stubs for routines that can't be configured
 * out with binary-only distribution.
 */
#include <sys/errno.h>
#include <sys/types.h>
#include <sys/des.h>
#include <sys/socket.h>
#include <sys/protosw.h>
#include <sys/domain.h>
#include <sys/osmp_lock.h>
#include <sys/time.h>
#include <sys/vfs.h>
#include <sys/vfs_stat.h>
#include <sys/vnode.h>
#include <net/if.h>
#include <ufs/quota.h>
#include <xv.h>

#if !defined(GENERIC) && !defined(lint)
setconf() { }
#endif !GENERIC && !lint

#ifndef SYSACCT
struct vnode savacctp;
sysacct() { return (ENODEV); }
acct() { }
#endif !SYSACCT
/* defines for NFS Clients and Servers */

#if !defined(NFSSERVER) 
slock udp_data_lock;
slock ku_dup_lock;
slock rfsget_lock;
slock rfs_export_lock;
#endif

#if !defined(NFSSERVER) && !defined(NFSCLIENT)
slock rrokinfo_lock;
#endif
#ifndef SYSACCT 
slock  cwd_lock;
#else
#ifndef SYSAUDIT
slock	cwd_lock;
#endif !SYSAUDIT
#endif !SYSACCT

#ifndef SYSAUDIT
auditsys() { return (0); }
au_sysaudit() { return (0); }
void au_pathbuild() { }
void cwfree() { }
void cwincr() { }
#endif !SYSAUDIT

#ifndef QUOTA
void qtinit() { }
int  qsync()  { return(0);  }
struct dquot *getinoquota() { return ((struct dquot *)0); }
int chkdq() { return (0); }
int chkiq() { return (0); }
void dqrele() { }
int closedq() { return (0); }
#endif !QUOTA

#ifndef NIT
struct ifnet *nit_ifwithaddr() { return ((struct ifnet *)0); }
nit_tap() {}
struct domain nitdomain =
	{ AF_NIT, "nit", 0, 0, 0, (struct protosw *)0, (struct protosw *)0 };
#endif !NIT

#include "snit.h"
#if NSNIT == 0
snit_intr() {}
void *nisoftc;
#endif NSNIT == 0

#include "ether.h"
#if NETHER == 0
int arpioctl() { return (ENOPROTOOPT); }
int localetheraddr() { return (0); }
#endif NETHER == 0

#include "kb.h"
#if NKB == 0
kbdreset() {}
kbdsettrans() {}
soltosunkbd() {}
suntosolkbd() {}
solkbd2ndbyte() {}
solkbd_init() {}
#endif NKB == 0

#include "ms.h"
#if NMS == 0
msintr() { }
#endif NMS == 0

#include "zs.h"
#if NZS == 0
zslevel6intr() { panic("level 6 interrupt and no ZS device configured"); }
#endif NZS == 0

#ifndef IPCSEMAPHORE
seminit() {}
semexit() {}
#endif !IPCSEMAPHORE

#ifndef IPCMESSAGE
msginit() {}
#endif !IPCMESSAGE

#ifndef IPCSHMEM
shmexec() {}
shmfork() {}
shmexit() {}
#endif !IPCSHMEM

#include "fpa.h"
#if NFPA == 0
int fpa_fork_context() { return (0); }
fpa_shutdown() {}
fpa_dorestore() {}
fpa_save() {}
fpa_restore() {}
#endif NFPA == 0

#ifndef UFS
int ilock() {}
int iunlock() {}
struct vnodeops *ufs_vnodeops;
int old_ufs_readdir() {}
int ufs_vnodeconf() {}
struct mount *mounttab = 0;
int mounttab_flags = 0;
struct inode *ifreeh = 0;
#endif

/* stubs needed when miscellaneous drivers are configured out */

#include "ei.h"
#if NEI == 0
eistop() {}		/* for autoconf.c */
#endif NEI == 0

#include "zs.h"
#if NZS == 0
zs_enable_prof() {}	/* for machdep.c on simulator kernels */
zs_disable_prof() {}	/* mor machdep.c on simulator kernels */
#endif NZS == 0

#include "cgtwo.h"
#if NCGTWO == 0
#ifndef S4000
cgtwo_enable_intrs() {}	/* for autoconf.c */
cgtwo_disable_intrs() {}	/* for autoconf.c */
cgtwo_set_iundirected() {}	/* for autoconf.c */
cgtwoputc() {}
#endif
#endif NCGTWO == 0


#include "win.h"
#if NWIN > 0

/* stubs needed when some frame buffer drivers are configured out */
#include "bwtwo.h"

#if NBWTWO == 0
bwtwoputc() {}
#endif NBWTWO == 0

#include "cgtwo.h"
#if NCGTWO == 0
# ifndef lint
cg2_putcolormap() {}	/* for pixrect/pr_dblbuf.c */
cgtwo_wait() {}		/* for pixrect/pr_dblbuf.c */
# endif
#endif NCGTWO == 0

#include "gpone.h"
#if NGPONE == 0
/*VARARGS*/
# ifndef lint
gp1_sync() {return(0);}		/* for pixrect/cg2_{colormap,rop}.c */
# endif
#endif NGPONE == 0

#include "cgfour.h"
#if NCGFOUR == 0
cg4_putattributes() {}	/* for pixrect/pr_plngrp.c */
cgfourputc() {}
#endif NCGFOUR == 0

#include "sga.h"
#if NSGA == 0
sgaputc() {}
sga_cg4save() {}
sga_cg4restore() {}
sga_rop() {}
sga_putcolormap() {}
sga_putattributes() {}
#endif

#else NWIN

/* stubs needed when windows are configured out */

#include "bwtwo.h"
#if NBWTWO > 0
mem_rop() {}
mem_putcolormap() {}
mem_putattributes() {}
#else NBWTWO > 0
bwtwoputc() {}
#endif NBWTWO > 0

#include "cgtwo.h"
#if NCGTWO > 0
cg2_rop() {}
cg2_putcolormap() {}
cg2_putattributes() {}
#endif NCGTWO > 0

#include "cgfour.h"
#if NCGFOUR > 0
/* mem_rop(), mem_putcolormap() taken care of above */
cg4_putattributes() {}
#else NCGFOUR > 0
cgfourputc() {}
#endif NCGFOUR > 0

#include "sga.h"
#if NSGA > 0
pr_clip() {}
#else NSGA > 0
sgaputc() {}
sga_cg4save() {}
sga_cg4restore() {}
#endif NSGA > 0

#endif NWIN

#ifndef CRYPT
/*ARGSUSED*/
# ifndef lint
int _des_crypt(buf, len, desp)
	char *buf;
	unsigned len;
	struct desparams *desp;
{ return (0); }
# endif
#endif

#if NXV == 0
# ifndef lint
char *vme_counter = 0;
/*ARGSUSED*/
init_clock (xxp)
char *xxp;
{
    return (0);
}

/*ARGSUSED*/
unsigned read_clock (xxp)
char *xxp;
{
    return (0);
}
# endif /* !lint */
#endif NXV

/*
 * Stubs for asynchio
 */
#ifndef LWP
thread_init_once() {}
thread_sleep() {}
thread_scheduler() {}
thread_wakeup() {}
thread_kill_gently() {}
thread_fork() { return -1; }
thread_init() {}
slock th_sleep_lock;
#endif !LWP

/*
 * stubs for device specific locks when the device is not configured.
 */
#include "cgtwo.h"
#if	NCGTWO == 0
# ifndef lint
slock cg2_lock;
# endif
#endif	NCGTWO == 0

#include "cgfour.h"
#if	NCGFOUR == 0
slock cg4_lock;
#endif	NCGFOUR == 0

#include "eg.h"
#if	NEG == 0
# ifndef lint
slock eg_lock;
# endif
#endif	NEG == 0

#include "ei.h"
#if	NEI == 0
# ifndef lint
slock ei_lock;
# endif
#endif	NEI == 0

#include "ex.h"
#if	NEX == 0
# ifndef lint
slock ex_lock;
# endif
#endif	NEX == 0

#include "zs.h"
#if	NZS == 0
slock zs_lock;
#endif	NZS == 0

#ifdef	kbus
#include "si.h"
#if	NSI == 0
int siintr() { return (0); }
#endif	NSI == 0
#endif	kbus

#ifndef WINSVJ
int svjwrite() { return (0); }
void svjsendevent() { }
int svjioctl() { return (0); }
void ws_dealloc_rec_q() { }
int svj_consume_input_event() { return (0); }
void svj_consume_event() { }
#endif !WINSVJ

#ifdef	Series4
inactivity_turn_on(){}
inactivity_turn_off(){}
#endif	Series4

#ifdef	S4000
flush_all_writebuffers(){}
flush_writebuffers_to(){}
flush_writebuffers_to_mem(){}
#endif	S4000
