#ifndef lint
static char *Solbourne_id =
"@(#) sdconf.c 1.2@(#) Solbourne id 1/11/94 19:38:16\n";
#endif
/*
 * Copyright 1988 Solbourne Computer, Inc.
 * All rights reserved.
 */

#include <sys/param.h>
#include <sys/types.h>
#include <sys/buf.h>
#include <mfg/dkio.h>
#include <dev/scsivar.h>
#include <dev/sdvar.h>

#include "sd.h"

#if NSD > 0
/* common command set error codes */
char *sd_ccs_err[] = {
	"\000no more sense",		/* 0x00 */
	"\001no index/address mark",	/* 0x01 */
	"\002no seek",			/* 0x02 */
	"\003write fault",		/* 0x03 */
	"\004drive not ready",		/* 0x04 */
	"\005drive not selected",	/* 0x05 */
	"\006no track zero",		/* 0x06 */
	"\006multiple drives selected",	/* 0x07 */
	"\010LUN comm error",		/* 0x08 */
	"\010track following error",	/* 0x09 */
	"\020id CRC/ECC error",		/* 0x10 */
	"\021unrecovered data error",	/* 0x11 */
	"\022id mark not found",	/* 0x12 */
	"\023data mark not found",	/* 0x13 */
	"\024record not found",		/* 0x14 */
	"\025seek error",		/* 0x15 */
	"\026recovered addr mark",	/* 0x16 */
	"\027recovered read retries",	/* 0x17 */
	"\030recovered read ECC",	/* 0x18 */
	"\031defect list error",	/* 0x19 */
	"\032parameter overrun",	/* 0x1A */
	"\033synchronous error",	/* 0x1B */
	"\034no primary defect list",	/* 0x1C */
	"\035compare error",		/* 0x1D */
	"\036recovered ID ECC",		/* 0x1E */
	"\040invalid command",		/* 0x20 */
	"\041illegal block address ",	/* 0x21 */
	"\042illegal function",		/* 0x22 */
	"\044illegal field in CDB",	/* 0x24 */
	"\045invalid LUN",		/* 0x25 */
	"\046illegal field in params",	/* 0x26 */
	"\047write protected",		/* 0x27 */
	"\050media changed",		/* 0x28 */
	"\051power_on/reset",		/* 0x29 */
	"\052mode select changed",	/* 0x2A */
	"\060incompatible catridge",	/* 0x30 */
	"\061media corrupted",		/* 0x31 */
	"\062no spare defect locations",/* 0x32 */
	"\100ram failure",		/* 0x40 */
	"\101datapath diagnostic error",/* 0x41 */
	"\102power on diagnostic error",/* 0x42 */
	"\103message reject error",	/* 0x43 */
	"\104internal control error",	/* 0x44 */
	"\105select/reselect failed",	/* 0x45 */
	"\106failed soft reset",	/* 0x46 */
	"\107SCSI parity error",	/* 0x47 */
	"\110initiator detected error",	/* 0x48 */
	"\111illegal message",		/* 0x49 */
					/* 0x50 - 0xFF ... */
	0
};

/* disk drive specific (vendor unique) error codes */
static char *sd_maxtor_err[] = {
	0				/* no vendor unique errors ... */
};

/*
 * disk configuration/capability table:
 * NOTE: the code will take care of retiring tags if the drive correctly
 * supports the QTAG_FULL status.  Putting entries here lets the
 * queue depth show correctly when booting.
 */
struct sd_tp	sd_tp[] = {
    {"MAXTOR  ",				8,	0,	sd_maxtor_err},

    /* 11200 with old firmware: Q just to controller */
    {"SEAGATE ST11200N        83",		26,	0,	0},

    /* WREN 8: Q just to controller */
    {"SEAGATE ST41",				12,	0,	0},

    /* Micropolis: Q just to controller */
    {"MICROP",					6,	0,	0},

    /* Elite 2: limit Q to 16 tags */
    {"SEAGATE ST42",				12,	16,	0},
    {0}
};

u_char	sdwchkmap[NSD];			/* write verify mask */
#endif
