#ifndef lint
static char *Solbourne_id =
"@(#) xd_conf.c 1.1@(#) Solbourne id 9/22/93 00:09:28\n";
#endif
/*
 * Copyright 1988 Solbourne Computer, Inc.
 * All rights reserved.
 */

#ifndef lint
static	char sccsid[] = "@(#)xd_conf.c 1.3 89/08/03 SMI";
#endif

/*
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */
#include "xd.h"

/*
 * Config dependent data structures for the Xylogics 751 driver.
 */
#include <sys/param.h>
#include <sys/buf.h>
#if	NCPUS > 1
#include <machine/multicpu.h>
#endif	NCPUS > 1
#include <smpdefs.h>
#include <dev/mbvar.h>
#include <mfg/dkio.h>
#include <dev/xdvar.h>
#include <machine/cpu.h>

int nxd = NXD;			/* So the driver can use these defines */
int nxdc = NXDC;

/*
 * Declare relevant structures if the devices exist
 */

/*
 * Unit structures.
 */
#if NXD > 0
struct xdunit xdunits[NXD];
#endif NXD

/*
 * Controller structures.
 */
#if NXDC > 0
struct xdctlr xdctlrs[NXDC];
struct xd_w_info xd_watch_info[NXDC];
char xd_lname[NXDC][8];		/* names for per controller locks */
#endif NXDC

/*
 * Generic structures.
 */
#if NXDC > 0
struct	mb_ctlr *xdcinfo[NXDC];
int	xd_vdma_runout[NXDC];
int	xd_wait_cmdblock[NXDC];
#endif NXDC

#if NXD > 0
struct	mb_device *xddinfo[NXD];
#endif NXD

/*
 * These shorts define the controller parameters the 7053 will get set with.
 *
 * xd_ctlrpar0 is a short containing the bits for iopb bytes 0x8 and 0x9
 * (which is the sector count field under normal operations)
 *
 * xd_ctlrpar1 is a short containing the bits for iopb byte 0xa. The driver
 * will shift this by 8, and or it into the xd_throttle field of the iopb
 * (also the cylinder field).
 *
 * see the file xdreg.h for the definitions of these bits.
 */
u_short xd_ctlrpar0 = XD_LWRD|XD_DACF|(xd_tdtv(1))|XD_ROR;

/*
 * This *must* be a short, as it will be shifted by 8 to be folded into the
 * iopb throttle variable.
 */
u_short xd_ctlrpar1 = XD_OVS|XD_ESWO|XD_ASR|XD_RBC|XD_ECC2;
/*
 * This *must* be a short.
 */
#ifdef sun3
u_short xd_ctlrpar2 = 20;
#else
#ifdef	solbourne
#ifdef	Series4
u_short xd_ctlrpar2 = 8;	/* 8 * 250usec = 2msec */
#endif	Series4
#ifdef	Series5
u_short xd_ctlrpar2 = 3;	/* 3 * 250usec */
#endif	Series5
#ifdef	Series6
u_short xd_ctlrpar2 = 2;	/* 2 * 250usec */
#endif	Series6
#ifdef	Series7
u_short xd_ctlrpar2 = 2;	/* 2 * 250usec */
#endif	Series7
#else	solbourne
u_short xd_ctlrpar2 = 0;	/* default == 2msec */
#endif	solbourne
#endif sun3
/* 
 * max number of transfers allowed each time the 753 becomes bus master
 * value of 0 => 256, 1 => 1 ...
 */
int xdthrottle = 0;		/* transfer burst count */

/*
 * the number of cbis preallocated per drive.
 */
#define	NCBIFREE_SMD	14		/* Number for SMD */
#define	NCBIFREE_IPI	24		/* Number for IPI */
int xd_ncbifree_smd = NCBIFREE_SMD;
int xd_ncbifree_ipi = NCBIFREE_IPI;
